unit fTestSrvMainIMPL;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Dialogs,
  Variants,
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, TestSrv_TLB, StdVcl;

const
  LOOP_COUNT = 1000;

type
  TTestClnt = class(TRemoteDataModule, ITestClnt)
  protected
    FCallback: OleVariant;
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
    procedure SetCallback(ACallback: OleVariant); safecall;
    procedure TEST1; safecall;
    procedure TEST2; safecall;
    function Callbacks(out O: OleVariant): WordBool; safecall;
  public
    procedure AfterConstruction; override;
    procedure BeforeDestruction; override;
  end;

implementation

uses fTestSrvMain;

{$R *.DFM}

class procedure TTestClnt.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

procedure TTestClnt.SetCallback(ACallback: OleVariant);
begin
  FCallback := ACallback;
end;

procedure TTestClnt.TEST1;
var
  Percent: Single;
  I: Integer;
  Stop: WordBool;
begin
  Stop := False;
  for I := 0 to LOOP_COUNT-1 do
  begin
    Percent := (I+1)*100/LOOP_COUNT;
    FCallback.Progress(Percent,Stop);
    if Stop then Break;
  end;
  if Stop
  then FCallback.Stopped
  else FCallback.Done;
end;

procedure TTestClnt.TEST2;
var
  Percent: Single;
  I,J,K: Integer;
  Stop: WordBool;
begin
  K := 0;
  Stop := False;
  for I := 0 to LOOP_COUNT-1 do
  begin
    Percent := (I+1)*100/LOOP_COUNT;
    J := Round(Percent/5); {Callback every 10%}
    if (J = K) and (I<>LOOP_COUNT-1) then Continue;
    K := J;
    FCallback.Progress(Percent,Stop);
    if Stop then Break;
  end;
  if Stop
  then FCallback.Stopped
  else FCallback.Done;
end;

procedure TTestClnt.AfterConstruction;
begin
  inherited;
  frmTestSrvMain.Add(Self);
end;

procedure TTestClnt.BeforeDestruction;
begin
  frmTestSrvMain.Delete(Self);
  inherited;
end;

function TTestClnt.Callbacks(out O: OleVariant): WordBool;
begin
  O := FCallback;
  Result := not VarIsEmpty(O);
end;

initialization
  TComponentFactory.Create(ComServer, TTestClnt, Class_TestClnt, ciMultiInstance, tmApartment);
end.
